diff --git a/doc/src/sgml/wal.sgml b/doc/src/sgml/wal.sgml
index ec62d17fbcc..79ac6c247f8 100644
--- a/doc/src/sgml/wal.sgml
+++ b/doc/src/sgml/wal.sgml
@@ -236,20 +236,20 @@
   </indexterm>
 
   <para>
-   By default, data pages are protected by checksums, but this can
-   optionally be disabled for a cluster. When enabled, each data page includes
-   a checksum that is updated when the page is written and verified each time
-   the page is read. Only data pages are protected by checksums; internal data
-   structures and temporary files are not.
+   By default, data pages are protected by checksums, but this can optionally
+   be disabled for a cluster. When enabled, each data page includes a checksum
+   that is updated when the page is written and verified each time the page is
+   read. Only data pages are protected by checksums; internal data structures
+   and temporary files are not.
   </para>
 
   <para>
    Checksums can be disabled when the cluster is initialized using <link
    linkend="app-initdb-data-checksums"><application>initdb</application></link>.
-   They can also be enabled or disabled at a later time either as an offline
-   operation or online in a running cluster allowing concurrent access. Data
-   checksums are enabled or disabled at the full cluster level, and cannot be
-   specified individually for databases, tables or replicated cluster members.
+   They can also be enabled or disabled at a later time as an offline
+   operation.  Data checksums are enabled or disabled at the full cluster
+   level, and cannot be specified individually for databases, tables or
+   replicated cluster members.
   </para>
 
   <para>
@@ -257,51 +257,11 @@
    value of the read-only configuration variable <xref
    linkend="guc-data-checksums" /> by issuing the command <command>SHOW
    data_checksums</command>.  <link linkend="functions-pg-control-init">
-   <literal>pg_control_init</literal></link> and
-   <link linkend="functions-pg-control-checkpoint">
-   <literal>pg_control_checkpoint</literal></link> can also be used for
-   inspecting the data checksum state at cluster initialization and current
-   checkpoint.  Data checksum states are often referred to as data checksum
-   versions using an integer representation due to how they were originally
-   implemented.  <xref linkend="data-checksums-mapping" /> contains a mapping
-   between state names and versions, which are defined in
-   <filename>src/include/storage/checksum.h</filename>.
+   <literal>pg_control_init</literal></link>
+    can also be used for
+   inspecting the data checksum state at cluster initialization.
   </para>
 
-  <table id="data-checksums-mapping">
-   <title>Data Checksums States and Version Mapping</title>
-   <tgroup cols="2">
-    <thead>
-     <row>
-      <entry>State</entry>
-      <entry>Version</entry>
-     </row>
-    </thead>
-
-    <tbody>
-     <row>
-      <entry>off</entry>
-      <entry>0</entry>
-     </row>
-
-     <row>
-      <entry>on</entry>
-      <entry>1</entry>
-     </row>
-
-     <row>
-      <entry>inprogress-off</entry>
-      <entry>2</entry>
-     </row>
-
-     <row>
-      <entry>inprogress-on</entry>
-      <entry>3</entry>
-     </row>
-    </tbody>
-   </tgroup>
-  </table>
-
   <para>
    When attempting to recover from page corruptions, it may be necessary to
    bypass the checksum protection. To do this, temporarily set the
@@ -314,126 +274,11 @@
    <para>
     The <link linkend="app-pgchecksums"><application>pg_checksums</application></link>
     application can be used to enable or disable data checksums, as well as
-    verify checksums, on an offline cluster.
-   </para>
-
-  </sect2>
-
-  <sect2 id="checksums-online-enable-disable" xreflabel="Online Enabling of Checksums">
-   <title>Online Enabling of Checksums</title>
-
-   <para>
-    Checksums can be enabled or disabled online, by calling the appropriate
-    <link linkend="functions-admin-checksum">functions</link>.
-   </para>
-
-   <para>
-    Both enabling and disabling data checksums happens in two phases, separated
-    by a checkpoint to ensure durability.  The different states, and their
-    transitions, are illustrated in <xref linkend="data-checksums-states-figure"/>
-    and discussed in further detail in this section.
-   </para>
-
-   <para>
-    <figure id="data-checksums-states-figure">
-     <title>Data Checksums States</title>
-     <mediaobject>
-      <imageobject>
-       <imagedata fileref="images/datachecksums.svg" format="SVG" width="100%"/>
-      </imageobject>
-     </mediaobject>
-    </figure>
-   </para>
-
-   <para>
-    Enabling checksums will set the cluster checksum state to
-    <literal>inprogress-on</literal>.  During this time, checksums will be
-    written but not verified. In addition to this, a background worker process
-    is started that enables checksums on all existing data in the cluster. Once
-    this worker has completed processing all databases in the cluster, the
-    checksum state will automatically switch to <literal>on</literal>. The
-    processing will consume two background worker processes, make sure that
-    <varname>max_worker_processes</varname> allows for at least two more
-    additional processes.
-   </para>
-
-   <para>
-    The process will initially wait for all open transactions to finish before
-    it starts, so that it can be certain that there are no tables that have been
-    created inside a transaction that has not committed yet and thus would not
-    be visible to the process enabling checksums. It will also, for each database,
-    wait for all pre-existing temporary tables to get removed before it finishes.
-    If long-lived temporary tables are used in an application it may be necessary
-    to terminate these application connections to allow the process to complete.
+    verify checksums, on an offline cluster.  The same operation must be
+    executed on every node in a replicated cluster before the cluster is
+    restarted.
    </para>
 
-   <para>
-    If the cluster is stopped while in <literal>inprogress-on</literal> state,
-    for any reason, or processing was interrupted, then the checksum enable
-    process must be restarted manually.  To do this, re-execute the function
-    <function>pg_enable_data_checksums()</function> once the cluster has been
-    restarted.  The process will start over, there is no support for resuming
-    work from where it was interrupted.  If the cluster is stopped while in
-    <literal>inprogress-off</literal>, then the checksum state will be set to
-    <literal>off</literal> when the cluster is restarted.
-   </para>
-
-   <para>
-    Disabling data checksums will set the data checksum state to
-    <literal>inprogress-off</literal>.  During this time, checksums will be
-    written but not verified.  After all processes acknowledge the change,
-    the state will automatically be set to <literal>off</literal>.
-   </para>
-
-   <para>
-    Disabling data checksums while data checksums are actively being enabled
-    will abort the current processing.
-   </para>
-
-   <sect3 id="checksums-online-system-impact">
-    <title>Impact on System of Online Operations</title>
-    <para>
-     Enabling data checksums can cause significant I/O to the system, as all of the
-     database pages will need to be rewritten, and will be written both to the
-     data files and the WAL. The impact may be limited by throttling using the
-     <parameter>cost_delay</parameter> and <parameter>cost_limit</parameter>
-     parameters of the <function>pg_enable_data_checksums()</function> function.
-    </para>
-
-    <para>
-     <itemizedlist>
-      <listitem><para>
-       I/O: all pages need to have data checksums calculated and written which
-       will generate a lot of dirty pages that will need to be flushed to disk,
-       as well as WAL logged.
-      </para></listitem>
-      <listitem><para>
-       Replication: When the standby receives the data checksum state change
-       in the WAL stream it will issue a <glossterm linkend="glossary-restartpoint">
-       restartpoint</glossterm> in order to flush the current state into the
-       <filename>pg_control</filename> file.  The restartpoint will flush the
-       current state to disk and will block redo until finished.  This in turn
-       will induce replication lag, which on synchronous standbys also blocks
-       the primary.  Reducing <xref linkend="guc-max-wal-size"/> before the
-       process is started can help with reducing the time it takes for the
-       restartpoint to finish.
-      </para></listitem>
-      <listitem><para>
-       Shutdown/Restart: If the server is shut down or restarted when data
-       checksums are being enabled, the process will not resume and all pages
-       need to be recalculated and rewritten.  Enabling data checksums should
-       be done when there is no need for regular maintenance or during a
-       service window.
-      </para></listitem>
-     </itemizedlist>
-    </para>
-
-    <para>
-     No I/O is incurred when disabling data checksums, but checkpoints are
-     still required.
-    </para>
-   </sect3>
-
   </sect2>
  </sect1>
 
diff --git a/src/backend/access/rmgrdesc/xlogdesc.c b/src/backend/access/rmgrdesc/xlogdesc.c
index 2468a7d2578..437bb0ab43c 100644
--- a/src/backend/access/rmgrdesc/xlogdesc.c
+++ b/src/backend/access/rmgrdesc/xlogdesc.c
@@ -55,40 +55,6 @@ get_wal_level_string(int wal_level)
 	return wal_level_str;
 }
 
-const char *
-get_checksum_state_string(uint32 state)
-{
-	switch (state)
-	{
-		case PG_DATA_CHECKSUM_VERSION:
-			return "on";
-		case PG_DATA_CHECKSUM_INPROGRESS_OFF:
-			return "inprogress-off";
-		case PG_DATA_CHECKSUM_INPROGRESS_ON:
-			return "inprogress-on";
-		case PG_DATA_CHECKSUM_OFF:
-			return "off";
-	}
-
-	Assert(false);
-	return "?";
-}
-
-void
-xlog2_desc(StringInfo buf, XLogReaderState *record)
-{
-	char	   *rec = XLogRecGetData(record);
-	uint8		info = XLogRecGetInfo(record) & ~XLR_INFO_MASK;
-
-	if (info == XLOG2_CHECKSUMS)
-	{
-		xl_checksum_state xlrec;
-
-		memcpy(&xlrec, rec, sizeof(xl_checksum_state));
-		appendStringInfoString(buf, get_checksum_state_string(xlrec.new_checksum_state));
-	}
-}
-
 void
 xlog_desc(StringInfo buf, XLogReaderState *record)
 {
@@ -104,8 +70,7 @@ xlog_desc(StringInfo buf, XLogReaderState *record)
 						 "tli %u; prev tli %u; fpw %s; wal_level %s; logical decoding %s; xid %u:%u; oid %u; multi %u; offset %" PRIu64 "; "
 						 "oldest xid %u in DB %u; oldest multi %u in DB %u; "
 						 "oldest/newest commit timestamp xid: %u/%u; "
-						 "oldest running xid %u; "
-						 "checksums %s; %s",
+						 "oldest running xid %u; %s",
 						 LSN_FORMAT_ARGS(checkpoint->redo),
 						 checkpoint->ThisTimeLineID,
 						 checkpoint->PrevTimeLineID,
@@ -124,7 +89,6 @@ xlog_desc(StringInfo buf, XLogReaderState *record)
 						 checkpoint->oldestCommitTsXid,
 						 checkpoint->newestCommitTsXid,
 						 checkpoint->oldestActiveXid,
-						 get_checksum_state_string(checkpoint->dataChecksumState),
 						 (info == XLOG_CHECKPOINT_SHUTDOWN) ? "shutdown" : "online");
 	}
 	else if (info == XLOG_NEXTOID)
@@ -203,9 +167,8 @@ xlog_desc(StringInfo buf, XLogReaderState *record)
 		xl_checkpoint_redo xlrec;
 
 		memcpy(&xlrec, rec, sizeof(xl_checkpoint_redo));
-		appendStringInfo(buf, "wal_level %s; checksums %s",
-						 get_wal_level_string(xlrec.wal_level),
-						 get_checksum_state_string(xlrec.data_checksum_version));
+		appendStringInfo(buf, "wal_level %s",
+						 get_wal_level_string(xlrec.wal_level));
 	}
 	else if (info == XLOG_LOGICAL_DECODING_STATUS_CHANGE)
 	{
@@ -280,21 +243,6 @@ xlog_identify(uint8 info)
 	return id;
 }
 
-const char *
-xlog2_identify(uint8 info)
-{
-	const char *id = NULL;
-
-	switch (info & ~XLR_INFO_MASK)
-	{
-		case XLOG2_CHECKSUMS:
-			id = "CHECKSUMS";
-			break;
-	}
-
-	return id;
-}
-
 /*
  * Returns a string giving information about all the blocks in an
  * XLogRecord.
